hdoj 1384 Intervals

Intervals

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3332    Accepted Submission(s):
1227

Problem Description

You are given n closed, integer intervals [ai, bi] and
n integers c1, ..., cn.

Write a program that:

> reads the
number of intervals, their endpoints and integers c1, ..., cn from the standard
input,

> computes the minimal size of a set Z of integers which has at
least ci common elements with interval [ai, bi], for each i = 1, 2, ...,
n,

> writes the answer to the standard output

Input

The first line of the input contains an integer n (1
<= n <= 50 000) - the number of intervals. The following n lines describe
the intervals. The i+1-th line of the input contains three integers ai, bi and
ci separated by single spaces and such that 0 <= ai <= bi <= 50 000 and
1 <= ci <= bi - ai + 1.

Process to the end of file.

Output

The output contains exactly one integer equal to the
minimal size of set Z sharing at least ci elements with interval [ai, bi], for
each i = 1, 2, ..., n.

Sample Input

5

3 7 3

8 10 3

6 8 1

1 3 1

10 11 1

Sample Output

6

题意:给出n个区间的左右端点,和这个区间内至少存在的在集合s中的点的个数,让你求集合s中最少有多少个点

题解:重在找到差分约束的约束条件,将约束条件转化为xj-xi<=k的形式,然后建立一条从i到j权值为k的边;

设maxl为区间的左端点,maxr为区间的右端点,S[i] 表示集合Z里面的元素在区间[0, i ]的个数,Maxl,Maxr分别表示所有区间里面的最左端和最右端,dist[]数组存储源点到某点的最短路。则由题意得限制条件

一 S[right] -  S[left-1] >= least 即[left, right]区间个数不小于least,转换得S[left-1] - S[right] <= least;

二 0 <= S[i] - S[i-1] <= 1转换得 S[i-1] - S[i] <= 0 && S[i] - S[i-1] <= 1。

第二个条件题中并没有给出,需要自己推导,因为仅仅靠题中的条件无法构建一个连通图,也就无法求最短路,因为s[i]表示的是集合Z里面的元素在区间[0, i ]的个数所以s[i]至多比s[i-1]大一也可能相等

然后根据限制条件建图

转化问题:题目需要求的是S[Maxr] - S[Maxl-1] >= ans 即S[Maxl-1] - S[Maxr] <= -ans。 若以Maxr为源点 ,而-ans就为Maxr到Maxl-1的最短路径的相反数,即-dist[Maxl-1]。

#include<stdio.h>
#include<string.h>
#include<queue>
#define INF 0x3f3f3f
#define MAX 200000
#include<algorithm>
using namespace std;
int n,ans;
int maxl,maxr;
int vis[MAX],dis[MAX];
int head[MAX];
struct node
{
	int u,v,w;
	int next;
}edge[MAX];
void add(int u,int v,int w)
{
	edge[ans].u=u;
	edge[ans].v=v;
	edge[ans].w=w;
	edge[ans].next=head[u];
	head[u]=ans++;
}
void init()
{
	ans=0;
	maxl=INF;
	maxr=0;
	memset(head,-1,sizeof(head));
}
void getmap()
{
	int i,j,a,b,c;
	while(n--)
	{
		scanf("%d%d%d",&a,&b,&c);
		maxl=min(maxl,a);
		maxr=max(maxr,b);
		add(b,a-1,-c);
	}
	for(i=maxl;i<=maxr;i++)
	{
		add(i,i-1,0);
		add(i-1,i,1);
	}
}
void spfa()
{
	int i,j;
	queue<int>q;
	memset(vis,0,sizeof(vis));
	for(i=maxl-1;i<=maxr;i++)//以maxr为源点,也可以以maxl为源点,不过要对建图稍作修改
	    dis[i]=INF;
	dis[maxr]=0;
	vis[maxr]=1;
	q.push(maxr);
	while(!q.empty())
	{
		int u=q.front();
		q.pop();
		vis[u]=0;
		for(i=head[u];i!=-1;i=edge[i].next)
		{
			int top=edge[i].v;
			if(dis[top]>dis[u]+edge[i].w)
			{
				dis[top]=dis[u]+edge[i].w;
				if(!vis[top])
				{
					vis[top]=1;
					q.push(top);
				}
			}
		}
	}
	printf("%d\n",-dis[maxl-1]);
}
int main()
{
	while(scanf("%d",&n)!=EOF)
	{
		init();
		getmap();
		spfa();
	}
	return 0;
}

  

时间: 2024-10-16 15:22:19

hdoj 1384 Intervals的相关文章

POJ 1384 Intervals (线性差分约束,根据不等式建图,然后跑spfa)

传送门: http://acm.hdu.edu.cn/showproblem.php?pid=1384 Intervals Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4841    Accepted Submission(s): 1815 Problem Description You are given n closed, in

POJ 1201 &amp;&amp; HDU 1384 Intervals(差分约束系统)

题目地址:POJ 1201   HDU 1384 根据题目意思,可以列出不等式如下: Sj-Si>=c; Si-S(i-1)>=0; S(i-1)-Si>=-1; 然后用最短路spfa来解决这个不等式.用max来当源点,0为终点.最终的-d[0]就是答案. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <

POJ 1201 &amp;amp;&amp;amp; HDU 1384 Intervals(差动制动系统)

职务地址:POJ 1201   HDU 1384 依据题目意思.能够列出不等式例如以下: Sj-Si>=c; Si-S(i-1)>=0; S(i-1)-Si>=-1; 然后用最短路spfa来解决这个不等式. 用max来当源点,0为终点. 终于的-d[0]就是答案. 代码例如以下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #inclu

HDU 1384 Intervals (差分约束)

Sample Input 5 3 7 3 8 10 3 6 8 1 1 3 1 10 11 1 Sample Output 6 题意:给你n个数u,v,w:要求在[u,v]区间至少取w个数(整数),求最少要取多少个数. S[v+1] - S[u] >= w, S[i+1] - S[i] >=0&&<=1,S[i] - S[i+1] <=-1. 在u,v+1之间建一条边,跑一遍SPFA即可. #include <iostream> #include <

hdu 1384 Intervals (差分约束)

/* 给你 n 个区间 [Ai, Bi],要求从每一个区间中至少选出 Ci 个数出来组成一个序列 问:满足上面条件的序列的最短长度是多少? 则对于 不等式 f(b)-f(a)>=c,建立 一条 b 到 a 的边 权值为 c,则求的最长路 即为 最小值(集合) 而且有隐含条件:0<=f(a)-f(a-1)<=1 则有边权关系(a,a-1,0)以及(a-1,a,-1); */ /* 一般地,差分约束系统分两类:求最大差和最小差 1.求最大差 建立形如 A-B<=C 的不等式.在原图中加

hdu 1384 Intervals

差分约束系统. 求最小值,用最长路来解决. #include<cstdio> #include<cstring> #include<cmath> #include<queue> #include<vector> #include<algorithm> using namespace std; const int maxn=50010; const int INF=0x7fffffff; struct abc { int startt;

hdu 1384 Intervals 差分约束系统

注意初始化 #include "stdio.h" #include "string.h" #include "algorithm" #include "queue" #include "vector" using namespace std; const int inf=0x7FFFFFFF; struct node { int to; int c; }; int d[50005],inq[50005];

HDU 1384 Intervals &amp;洛谷[P1250]种树

差分约束 差分约束的裸题,关键在于如何建图 我们可以把题目中给出的区间端点作为图上的点,此处应注意,由于区间中被标记的点的个数满足区间加法,这里与前缀和类似,对于区间[L..R]来说,我们加入一条从L-1指向R的边,边权为ci. 这样还不够,因为这样建下来的图是离散的,我们还需要去挖掘题目中的隐藏条件,我们可以发现,区间[L..L]的c值大于零小于一,所以我们可以加入adde(L-1,L,0);adde(L,L-1,-1); 按理来说差分约束的题需要构造一个源点以防图不连通,但由于本题的隐含条件

HDU 1384 Intervals【差分约束-SPFA】

类型:给出一些形如a−b<=k的不等式(或a−b>=k或a−b<k或a−b>k等),问是否有解[是否有负环]或求差的极值[最短/长路径].例子:b−a<=k1,c−b<=k2,c−a<=k3.将a,b,c转换为节点:k1,k2,k3转换为边权:减数指向被减数,形成一个有向图: 由题可得(b−a) + (c−b) <= k1+k2,c−a<=k1+k2.比较k1+k2与k3,其中较小者就是c−a的最大值.由此我们可以得知求差的最大值,即上限被约束,此时我